<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: advertising_manager.php
| Author: Christian Damsgaard Jrgensen (PMM)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";

if (!checkrights("ADM") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../../index.php"); }

if (file_exists(INFUSIONS."advertising_manager/locale/".$settings['locale'].".php")) {
	include INFUSIONS."advertising_manager/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."advertising_manager/locale/English.php";
}

include INFUSIONS."advertising_manager/infusion_db.php";

require_once INCLUDES."html_buttons_include.php";

function get_description($position, $array) {
	
	global $locale;
	
	$position = str_replace($array, $locale['adm_positions'], $position);
	return $position;
}

if (isset($_POST['save'])) {
	$ad_name = stripinput($_POST['ad_name']);
	$ad_html = addslash($_POST['ad_html']);
	$ad_position = stripinput($_POST['ad_position']);
	$ad_start_date = 0; $ad_end_date = 0;
	if ($_POST['ad_start']['mday'] != "--" && $_POST['ad_start']['mon'] != "--" && $_POST['ad_start']['year'] != "----") {
		$ad_start_date = mktime($_POST['ad_start']['hours'],$_POST['ad_start']['minutes'],0,$_POST['ad_start']['mon'],$_POST['ad_start']['mday'],$_POST['ad_start']['year']);
	}
	if ($_POST['ad_end']['mday'] != "--" && $_POST['ad_end']['mon'] != "--" && $_POST['ad_end']['year'] != "----") {
		$ad_end_date = mktime($_POST['ad_end']['hours'],$_POST['ad_end']['minutes'],0,$_POST['ad_end']['mon'],$_POST['ad_end']['mday'],$_POST['ad_end']['year']);
	}
	if (isset($_POST['ad_id']) && isnum($_POST['ad_id'])) {
		$result = dbquery("UPDATE ".DB_ADVERTISING_MANAGER." SET ad_name='$ad_name', ad_html='$ad_html', ad_start='$ad_start_date', ad_end='$ad_end_date' WHERE ad_id='".$_POST['ad_id']."'");
		redirect(FUSION_SELF.$aidlink);
	} else {
		$result = dbquery("INSERT INTO ".DB_ADVERTISING_MANAGER." (ad_name, ad_html, ad_position, ad_start, ad_end) VALUES ('$ad_name', '$ad_html', '$ad_position', '".($ad_start_date != 0 ? $ad_start_date : time())."', '$ad_end_date')");
		redirect(FUSION_SELF.$aidlink);
	}
} elseif (isset($_POST['delete']) && (isset($_POST['ad_id']) && isnum($_POST['ad_id']))) {
	$result = dbquery("DELETE FROM ".DB_ADVERTISING_MANAGER." WHERE ad_id='".$_POST['ad_id']."'");
	redirect(FUSION_SELF.$aidlink);
} else {
	$result = dbquery("SELECT ad_id, ad_name, ad_position FROM ".DB_ADVERTISING_MANAGER." ORDER BY ad_name");
	$rows = dbrows($result);
	if ($rows != 0) {
		$editlist = ""; $sel = "";
		while ($data = dbarray($result)) {
			if ((isset($_POST['ad_id']) && isnum($_POST['ad_id'])) || (isset($_GET['ad_id']) && isnum($_GET['ad_id']))) {
				$ad_id = isset($_POST['ad_id']) ? $_POST['ad_id'] : $_GET['ad_id'];
				$sel = ($ad_id == $data['ad_id'] ? " selected='selected'" : "");
			}
			$editlist .= "<option value='".$data['ad_id']."'$sel>".$data['ad_name']."</option>\n";
		}
		opentable($locale['adm400']);
		echo "<div style='text-align:center'>\n<form name='selectform' method='post' action='".FUSION_SELF.$aidlink."&amp;action=edit'>\n";
		echo "<select name='ad_id' class='textbox' style='width:300px'>\n".$editlist."</select>\n";
		echo "<input type='submit' name='edit' value='".$locale['adm401']."' class='button' />\n";
		echo "<input type='submit' name='delete' value='".$locale['adm402']."' onclick='return DeleteAd();' class='button' />\n";
		echo "</form>\n</div>\n";
		closetable();
	}
	
	if ((isset($_GET['action']) && $_GET['action'] == "edit") && (isset($_POST['ad_id']) && isnum($_POST['ad_id'])) || (isset($_GET['ad_id']) && isnum($_GET['ad_id']))) {
		$result = dbquery("SELECT * FROM ".DB_ADVERTISING_MANAGER." WHERE ad_id='".(isset($_POST['ad_id']) ? $_POST['ad_id'] : $_GET['ad_id'])."' LIMIT 0,1");
		if (dbrows($result)) {
			$data = dbarray($result);
			$ad_name = $data['ad_name'];
			$ad_html = phpentities(stripslashes($data['ad_html']));
			if ($data['ad_start'] > 0) $ad_start = getdate($data['ad_start']);
			if ($data['ad_end'] > 0) $ad_end = getdate($data['ad_end']);
		} else {
			redirect(FUSION_SELF.$aidlink);
		}
	}
	if ((isset($_POST['edit']) && (isset($_POST['ad_id']) && isnum($_POST['ad_id']))) || (isset($_GET['ad_id']) && isnum($_GET['ad_id']))) {
		$edit = true;
		opentable($locale['adm403']);
	} else {
		$edit = false;
		$ad_name = "";
		$ad_html = "";
		opentable($locale['adm404']);
	}
	$ad_position_opts  = array(
		"pre_article",
		"sub_article",
		"news_prepost_x",
		"news_prepost_1",
		"news_prepost_even",
		"sub_news_idx",
		"news_sub_readmore",
		"custompages-pre-content",
		"custompages-after-content",
		"pre_forum_thread",
		"forum_thread_prepost_x",
		"forum_thread_prepost_1",
		"forum_thread_prepost_even",
		"sub_forum_post_message",
		"sub_forum_post",
		"sub_forum_thread_table",
		"sub_forum_thread",
		"pre_forum_idx",
		"sub_forum_idx_table",
		"sub_forum_idx",
		"pre_download_idx",
		"sub_download_idx",
		"pre_download_cat",
		"pre_album_info",
		"sub_album_info",
		"photogallery_photo_x",
		"photogallery_photo_desc",
		"pre_faq_idx"
	);
	$num_of_positions = count($ad_position_opts);
	$result2 = dbquery("SELECT ad_position FROM ".DB_ADVERTISING_MANAGER." ORDER BY ad_position");
	$new_array = array(); $remove = array();
	if (dbrows($result2)) {
		while ($data2 = dbarray($result2)) {
			$remove[] = $data2['ad_position'];
		}
		$new_array = array_diff($ad_position_opts, $remove);
	} else {
		$new_array = $ad_position_opts;
	}
	$position_list = "";
	foreach ($new_array as $ad_position_opt) {
		$text = get_description($ad_position_opt, $ad_position_opts);
		$position_list .= "<option value='".$ad_position_opt."'>".$text."</option>\n";
	}
	echo "<form name='inputform' method='post' action='".FUSION_SELF.$aidlink."'>\n";
	echo "<table cellpadding='0' cellspacing='0' class='center'>\n<tr>\n";
	echo "<td width='100' class='tbl'>".$locale['adm405']."</td>\n";
	echo "<td width='80%' class='tbl'><input type='text' name='ad_name' value='".$ad_name."' class='textbox' style='width: 300px'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "")." /></td>\n</tr>\n";
	if (!$edit) {
		echo "<tr>\n";
		echo "<td width='100' class='tbl'>".$locale['adm406']."</td>\n";
		echo "<td width='80%' class='tbl'><select name='ad_position' class='textbox' style='width: 300px'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">".$position_list."</select></td>\n</tr>\n";
	}
	echo "<tr>\n";
	echo "<td valign='top' width='100' class='tbl'>".$locale['adm407']."</td>\n";
	echo "<td width='80%' class='tbl'><textarea name='ad_html' cols='95' rows='10' class='textbox' style='width:98%'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">".$ad_html."</textarea></td>\n";
	echo "</tr>\n";
	if ($edit || $rows < $num_of_positions) {
		echo "<tr>\n<td class='tbl'></td>\n<td class='tbl'>\n";
		echo display_html("inputform", "ad_html", true, true, true, IMAGES);
		echo "</tr>\n";
	}
	echo "<tr>\n";
	echo "<td class='tbl'>".$locale['adm408']."</td>\n";
	echo "<td class='tbl'><select name='ad_start[mday]' class='textbox'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">\n<option>--</option>\n";
	for ($i=1;$i<=31;$i++) echo "<option".(isset($ad_start['mday']) && $ad_start['mday'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> <select name='ad_start[mon]' class='textbox'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">\n<option>--</option>\n";
	for ($i=1;$i<=12;$i++) echo "<option".(isset($ad_start['mon']) && $ad_start['mon'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> <select name='ad_start[year]' class='textbox'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">\n<option>----</option>\n";
	for ($i=(isset($ad_start['year']) && $ad_start['year'] != "----" ? $ad_start['year'] : date('Y'));$i<=2015;$i++) echo "<option".(isset($ad_start['year']) && $ad_start['year'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> / <select name='ad_start[hours]' class='textbox'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">\n";
	for ($i=0;$i<=24;$i++) echo "<option".(isset($ad_start['hours']) && $ad_start['hours'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> : <select name='ad_start[minutes]' class='textbox'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">\n";
	for ($i=0;$i<=60;$i++) echo "<option".(isset($ad_start['minutes']) && $ad_start['minutes'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> : 00 ".$locale['adm410']."</td>\n";
	echo "</tr>\n<tr>\n";
	echo "<td class='tbl'>".$locale['adm409']."</td>\n";
	echo "<td class='tbl'><select name='ad_end[mday]' class='textbox'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">\n<option>--</option>\n";
	for ($i=1;$i<=31;$i++) echo "<option".(isset($ad_end['mday']) && $ad_end['mday'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> <select name='ad_end[mon]' class='textbox'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">\n<option>--</option>\n";
	for ($i=1;$i<=12;$i++) echo "<option".(isset($ad_end['mon']) && $ad_end['mon'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> <select name='ad_end[year]' class='textbox'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">\n<option>----</option>\n";
	for ($i=(isset($ad_end['year']) && $ad_end['year'] != "----" ? $ad_end['year'] : date('Y'));$i<=2015;$i++) echo "<option".(isset($ad_end['year']) && $ad_end['year'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> / <select name='ad_end[hours]' class='textbox'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">\n";
	for ($i=0;$i<=24;$i++) echo "<option".(isset($ad_end['hours']) && $ad_end['hours'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> : <select name='ad_end[minutes]' class='textbox'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "").">\n";
	for ($i=0;$i<=60;$i++) echo "<option".(isset($ad_end['minutes']) && $ad_end['minutes'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> : 00 ".$locale['adm410']."</td>\n";
	echo "</tr>\n<tr>\n";
	echo "<td align='center' colspan='2' class='tbl'><br />\n";
	if ($edit) {
		echo "<input type='hidden' name='ad_id' value='".(isset($_POST['ad_id']) ? $_POST['ad_id'] : $_GET['ad_id'])."' />\n";
	}
	echo "<input type='submit' name='save' value='".$locale['adm411']."' class='button'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "")." />\n";
	echo "<input type='reset' name='reset' value='".$locale['adm412']."' class='button'".(!$edit && $rows >= $num_of_positions ? " disabled='disabled'" : "")." /></td>\n";
	echo "</tr>\n</table>\n</form>\n";
	closetable();
	echo "<script type='text/javascript'>\nfunction DeleteAd() {\n";
	echo "return confirm('".$locale['adm413']."');\n}\n</script>\n";
}

require_once THEMES."templates/footer.php";
?>